import string
from Products.PloneNewsLetter import install_globals
from Products.PloneNewsLetter import PloneNewsLetter
from Products.PloneNewsLetter.global_symbols import *
from Products.PloneNewsLetter.Installation import Installation
from Products.CMFCore.utils import getToolByName

fti_list = (
    PloneNewsLetter.factory_type_information,
    )

fti_list2 = (
    PloneNewsLetter.factory_type_information2,
    )
types_list = (
    "PloneNewsLetter",
    )
skin_name = "PloneNewsLetter"
i18n_name = "PloneNewsLetter"
perms_list = (PloneNewsLetter_editPermission, PloneNewsLetter_addPermission, )

def addPortalProperties(self, id, title):
    """
    Adds newsletter_properties to portal_properties 
    """
    if id not in self.portal_properties.objectIds():
        portal_properties = getToolByName(self, 'portal_properties')
        portal_properties.addPropertySheet(id, title)
        p=getattr(self.portal_properties, id)
        if not hasattr(p,'email'):
            # email_from_address as it is found in a Plone Site at the root
            p._setProperty('email', self.email_from_address , 'string')
        if not hasattr(p,'days_offset'):
            p._setProperty('days_offset', 15, 'int')
        if not hasattr(p,'excluded_content_types'):
            p._setProperty('excluded_content_types', (), 'lines')
        if not hasattr(p,'default_content_types'):
            types_tool = getToolByName(self, 'portal_types')
            content_types = types_tool.listContentTypes()
            p._setProperty('default_content_types', content_types, 'lines')

def install(self):
    installation=Installation(self)
    installation.setPermissions(perms_list)
    installation.setupTypesandSkins(fti_list, skin_name, install_globals, fti_list2 = fti_list2)
    for ctype in types_list:
        validation = [
              ('%s_editForm' % (ctype), 'validate_id,validate_%s_edit' % ctype, ),
              ('%s_contentForm' % (ctype), 'validate_id,validate_%s_content' % ctype, ),
              ('%s_previewForm' % (ctype), 'validate_id,validate_%s_preview' % ctype, ),
              ]
        installation.addFormValidators(validation)
        lowertype=ctype.lower()
        transitions = [
              ('%s.%s_editForm.success' % (lowertype, ctype ), 'script:%s_edit' % (ctype), ),
              ('%s.%s_editForm.failure' % (lowertype, ctype ), '%s_editForm' % (ctype), ),
              ('%s.%s_edit.success' % (lowertype, ctype ), 'action:edit', ),
              ('%s.%s_edit.failure' % (lowertype, ctype ), 'action:edit', ),
              ('%s.%s_contentForm.success' % (lowertype, ctype ), 'script:%s_content' % (ctype), ),
              ('%s.%s_contentForm.failure' % (lowertype, ctype ), '%s_contentForm' % (ctype), ),
              ('%s.%s_content.success' % (lowertype, ctype ), 'action:content', ),
              ('%s.%s_content.failure' % (lowertype, ctype ), 'action:content', ),
              ('%s.%s_previewForm.success' % (lowertype, ctype ), 'script:%s_preview' % (ctype), ),
              ('%s.%s_previewForm.failure' % (lowertype, ctype ), '%s_previewForm' % (ctype), ),
              ('%s.%s_preview.success' % (lowertype, ctype ), 'action:preview', ),
              ('%s.%s_preview.failure' % (lowertype, ctype ), 'action:preview', ),
              ]
        installation.addNavigationTransitions(transitions)
    #domain=string.lower(i18n_name)
    #poPrefix='%s_' % domain
    #installation.installMessageCatalog(self, install_globals, domain, poPrefix)
    addPortalProperties(self, 'newsletter_properties', 'Newsletter Properties')
    return installation.report()
